//
//  NSString+AGEncryption.m
//  AGCategoryManager
//
//  Created by Ager on 16/3/13.
//  Copyright © 2016年 Ager. All rights reserved.
//

#import "NSString+AGEncryption.h"
#import <CommonCrypto/CommonCrypto.h>

@implementation NSString (AGEncryption)

- (NSString *)AG_Encryption_MD2{
    unsigned char result[CC_MD2_DIGEST_LENGTH];
    //调用MD5加密
    CC_MD2([self UTF8String], (CC_LONG)self.length, result);
    NSMutableString *resultStr = [[NSMutableString alloc] initWithCapacity:CC_MD2_DIGEST_LENGTH];
    for(int i = 0;i < CC_MD2_DIGEST_LENGTH ; i++){
        [resultStr appendFormat:@"%02x",result[i]];
    }
    return [resultStr copy];
}


- (NSString *)AG_Encryption_MD4{
    unsigned char result[CC_MD4_DIGEST_LENGTH];
    //调用MD5加密
    CC_MD4([self UTF8String], (CC_LONG)self.length, result);
    NSMutableString *resultStr = [[NSMutableString alloc] initWithCapacity:CC_MD4_DIGEST_LENGTH];
    for(int i = 0;i < CC_MD4_DIGEST_LENGTH ; i++){
        [resultStr appendFormat:@"%02x",result[i]];
    }
    return [resultStr copy];
}

- (NSString *)AG_Encryption_MD5{
    
    unsigned char result[CC_MD5_DIGEST_LENGTH];
    //调用MD5加密
    CC_MD5([self UTF8String], (CC_LONG)self.length, result);
    NSMutableString *resultStr = [[NSMutableString alloc] initWithCapacity:CC_MD5_DIGEST_LENGTH];
    for(int i = 0;i < CC_MD5_DIGEST_LENGTH ; i++){
        [resultStr appendFormat:@"%02x",result[i]];
    }
    return [resultStr copy];
}


- (NSString *)AG_Encryption_SHA1{
    
    unsigned char result[CC_SHA1_DIGEST_LENGTH];
    //调用MD5加密
    CC_SHA1([self UTF8String], (CC_LONG)self.length, result);
    NSMutableString *resultStr = [[NSMutableString alloc] initWithCapacity:CC_SHA1_DIGEST_LENGTH];
    for(int i = 0;i < CC_SHA1_DIGEST_LENGTH ; i++){
        [resultStr appendFormat:@"%02x",result[i]];
    }
    return [resultStr copy];
}

- (NSString *)AG_Encryption_SHA224{
    unsigned char result[CC_SHA224_DIGEST_LENGTH];
    //调用MD5加密
    CC_SHA224([self UTF8String], (CC_LONG)self.length, result);
    NSMutableString *resultStr = [[NSMutableString alloc] initWithCapacity:CC_SHA224_DIGEST_LENGTH];
    for(int i = 0;i < CC_SHA224_DIGEST_LENGTH ; i++){
        [resultStr appendFormat:@"%02x",result[i]];
    }
    return [resultStr copy];

}

- (NSString *)AG_Encryption_SHA256{
    unsigned char result[CC_SHA256_DIGEST_LENGTH];
    //调用MD5加密
    CC_SHA256([self UTF8String], (CC_LONG)self.length, result);
    NSMutableString *resultStr = [[NSMutableString alloc] initWithCapacity:CC_SHA256_DIGEST_LENGTH];
    for(int i = 0;i < CC_SHA256_DIGEST_LENGTH ; i++){
        [resultStr appendFormat:@"%02x",result[i]];
    }
    return [resultStr copy];

}

- (NSString *)AG_Encryption_SHA384{
    unsigned char result[CC_SHA384_DIGEST_LENGTH];
    //调用MD5加密
    CC_SHA384([self UTF8String], (CC_LONG)self.length, result);
    NSMutableString *resultStr = [[NSMutableString alloc] initWithCapacity:CC_SHA384_DIGEST_LENGTH];
    for(int i = 0;i < CC_SHA384_DIGEST_LENGTH ; i++){
        [resultStr appendFormat:@"%02x",result[i]];
    }
    return [resultStr copy];

}

- (NSString *)AG_Encryption_SHA512{
    unsigned char result[CC_SHA512_DIGEST_LENGTH];
    //调用MD5加密
    CC_SHA512([self UTF8String], (CC_LONG)self.length, result);
    NSMutableString *resultStr = [[NSMutableString alloc] initWithCapacity:CC_SHA512_DIGEST_LENGTH];
    for(int i = 0;i < CC_SHA512_DIGEST_LENGTH ; i++){
        [resultStr appendFormat:@"%02x",result[i]];
    }
    return [resultStr copy];

}


@end
